;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 05.02.2024 ;; Busy soft ;; Dimotex64 ;;
;; Dithered monochrom texture generator ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;     Compiled in  SjASMPlus 1.20.2    ;;
;; https://github.com/z00m128/sjasmplus ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	IFNDEF codefile : DEFINE codefile Dimotex.cod : ENDIF
	IFNDEF tapefile : DEFINE tapefile Dimotex.tap : ENDIF
	IFNDEF snapfile : DEFINE snapfile Dimotex.sna : ENDIF

	DEFINE	meno	'Dimotex 64'

	DEVICE	ZXSPECTRUM48
	OUTPUT	codefile
	ORG	#8000

start	add	b
	xor	c
	sub	c
	and	c
	add	c
	or	c
	ld	a,c
	ld	a,h

slucka	ld	hl,offset+1
	inc	(hl)
	res	3,(hl)
offset	ld	l,#07
	ld	a,(hl)
	ld	(matika),a

	call	#0DAF
	ld	a,#C0
linlop	dec	a
	push	af
	ld	c,#00
	call	#22B0
	dec	l
bytlop	inc	l
	ld	e,#01

matpix	ld	a,b
matika	nop
	add	a,a
	ld	d,a
	ld	a,r
	add	a,a
	cp	d
	rl	e
	inc	c
	jr	nc,matpix
	ld	(hl),e

	ld	a,e
	out	(#fe),a

	jr	nz,bytlop
	pop	af
	jr	nz,linlop

	ld	b,h
wait	halt
	djnz	wait
	jr	slucka

length	=	$-start

	OUTEND

;; Developing snap ;;

runsna	ei
	ld	bc,start
	ld	a,c
	push	bc
	ret

;; Loading basic

	INCLUDE	"BasicLib.asm"	;; https://github.com/z00m128/sjasmplus/tree/master/examples/BasicLib

line_useval = 1
baszac
	LINE : db rem,'Busy soft 08.02.2024'	: LEND
	LINE : db clear : NUM start-1		: LEND
	LINE : db load,'"',meno,'"',code	: LEND
	LINE : db rand,usr : NUM start		: LEND

baslen	=	$-baszac

;; Generating final TAP file

	EMPTYTAP tapefile
	SAVESNA	 snapfile , runsna
	SAVETAP	 tapefile , BASIC , meno , baszac , baslen , 0
	SAVETAP	 tapefile ,  CODE , meno , start  , length

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
